diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
index ef403fab2..3d556c9ae 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
@@ -1,31 +1,44 @@
 package net.minecraft.core.world.pos;
 
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.Chunk;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2ic;
 
-public final class ChunkPos
-    implements Pos2i<ChunkPos> {
+import java.io.Externalizable;
+import java.io.IOException;
+import java.io.ObjectInput;
+import java.io.ObjectOutput;
+
+public final class ChunkPos implements Externalizable, Cloneable, ChunkPosc {
     public int x;
     public int z;
 
+    public ChunkPos() {
+        this.x = 0;
+        this.z = 0;
+    }
+
     public ChunkPos(final int x, final int z) {
         this.x = x;
         this.z = z;
     }
 
-    public ChunkPos(final @NotNull TilePos tilePos) {
+    public ChunkPos(final @NotNull TilePosc tilePos) {
         this(
-            Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X),
-            Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z)
+            Math.floorDiv(tilePos.x(), Chunk.CHUNK_SIZE_X),
+            Math.floorDiv(tilePos.z(), Chunk.CHUNK_SIZE_Z)
         );
     }
 
-    public ChunkPos(final @NotNull ChunkPos chunkPos) {
+    public ChunkPos(final @NotNull ChunkPosc chunkPos) {
         this(
-            chunkPos.x,
-            chunkPos.z
+            chunkPos.x(),
+            chunkPos.z()
         );
     }
 
@@ -46,25 +59,125 @@ public final class ChunkPos
         return this.z;
     }
 
-    public @NotNull ChunkPos add(final int x, final int z) {
-        return new ChunkPos(this.x + x, this.z + z);
+    @Override
+    public @NotNull ChunkPos add(int x, int z, @NotNull ChunkPos dest) {
+        return dest.set(this.x + x, this.z + z);
+    }
+
+    @Override
+    public @NotNull ChunkPos add(@NotNull Vector2ic v, @NotNull ChunkPos dest) {
+        return add(v.x(), v.y(), dest);
+    }
+
+    @Override
+    public @NotNull ChunkPos add(@NotNull Direction dir, @NotNull ChunkPos dest) {
+        return add(dir.getOffsetX(), dir.getOffsetZ(), dest);
+    }
+
+    public @NotNull ChunkPos add(int x, int z) {
+        return add(x, z, this);
+    }
+
+    public @NotNull ChunkPos add(@NotNull Vector2ic v) {
+        return add(v, this);
+    }
+
+    public @NotNull ChunkPos add(@NotNull Direction dir) {
+        return add(dir, this);
+    }
+
+    @Override
+    public @NotNull ChunkPos sub(int x, int z, @NotNull ChunkPos dest) {
+        return dest.set(this.x - x, this.z - z);
+    }
+
+    @Override
+    public @NotNull ChunkPos sub(@NotNull Vector2ic v, @NotNull ChunkPos dest) {
+        return sub(v.x(), v.y(), dest);
+    }
+
+    @Override
+    public @NotNull ChunkPos sub(@NotNull Direction dir, @NotNull ChunkPos dest) {
+        return sub(dir.getOffsetX(), dir.getOffsetZ(), dest);
+    }
+
+    public @NotNull ChunkPos sub(int x, int z) {
+        return sub(x, z, this);
+    }
+
+    public @NotNull ChunkPos sub(@NotNull Vector2ic v) {
+        return sub(v, this);
     }
 
-    public @NotNull TilePos toTilePos(final @NotNull ChunkTilePos chunkTilePos) {
-        return new TilePos(this, chunkTilePos);
+    public @NotNull ChunkPos sub(@NotNull Direction dir) {
+        return sub(dir, this);
+    }
+
+    @Override
+    public double distance(@NotNull ChunkPosc pos) {
+        int dx = this.x - pos.x();
+        int dz = this.z - pos.z();
+        return org.joml.Math.sqrt(dx * dx + dz * dz);
+    }
+
+    @Override
+    public double distanceSquared(@NotNull ChunkPosc pos) {
+        int dx = this.x - pos.x();
+        int dz = this.z - pos.z();
+        return dx * dx + dz * dz;
+    }
+
+    @Override
+    public boolean inBounds(@NotNull WorldSource source) {
+        return
+            this.x >= Math.floorDiv(World.MIN_BLOCK_X, Chunk.CHUNK_SIZE_X) &&
+                this.z >= Math.floorDiv(World.MIN_BLOCK_Z, Chunk.CHUNK_SIZE_Z) &&
+                this.x <= Math.floorDiv(World.MAX_BLOCK_X, Chunk.CHUNK_SIZE_X) &&
+                this.z <= Math.floorDiv(World.MAX_BLOCK_Z, Chunk.CHUNK_SIZE_Z);
+    }
+
+    @Override
+    public boolean equals(int x, int z) {
+        return this.x == x && this.z == z;
+    }
+
+
+    public @NotNull ChunkPos set(int x, int z) {
+        this.x = x;
+        this.z = z;
+        return this;
+    }
+
+    public @NotNull ChunkPos set(@NotNull TilePosc pos) {
+        return set(Math.floorDiv(pos.x(), Chunk.CHUNK_SIZE_X), Math.floorDiv(pos.z(), Chunk.CHUNK_SIZE_Z));
     }
 
     @Override
     public boolean equals(final Object obj) {
-        if (!(obj instanceof final @NotNull ChunkPos other)) {
-            return false;
-        } else {
+        if (obj instanceof final @NotNull ChunkPos other) {
             return this.x == other.x && this.z == other.z;
         }
+        return false;
     }
 
     @Override
     public int hashCode() {
         return MathHelper.cantor(this.x, this.z);
     }
+
+    @Override
+    public void writeExternal(ObjectOutput out) throws IOException {
+        out.writeInt(this.x);
+        out.writeInt(this.z);
+    }
+
+    @Override
+    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
+        set(in.readInt(), in.readInt());
+    }
+
+    @Override
+    protected Object clone() throws CloneNotSupportedException {
+        return super.clone();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPosc.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPosc.java
new file mode 100644
index 000000000..d70ca71b0
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPosc.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.world.pos;
+
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2ic;
+
+/**
+ * Chunk coordinate in world
+ */
+public interface ChunkPosc {
+    int x();
+
+    int z();
+
+    @NotNull ChunkPos add(int x, int z, @NotNull ChunkPos dest);
+
+    @NotNull ChunkPos add(@NotNull Vector2ic v, @NotNull ChunkPos dest);
+
+    @NotNull ChunkPos add(@NotNull Direction dir, @NotNull ChunkPos dest);
+
+    @NotNull ChunkPos sub(int x, int z, @NotNull ChunkPos dest);
+
+    @NotNull ChunkPos sub(@NotNull Vector2ic v, @NotNull ChunkPos dest);
+
+    @NotNull ChunkPos sub(@NotNull Direction dir, @NotNull ChunkPos dest);
+
+    double distance(@NotNull ChunkPosc pos);
+
+    double distanceSquared(@NotNull ChunkPosc pos);
+
+    boolean inBounds(@NotNull WorldSource source);
+
+    boolean equals(int x, int z);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java
index 75ca95dc9..9fd7f0933 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePos.java
@@ -1,18 +1,31 @@
 package net.minecraft.core.world.pos;
 
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
+import org.joml.Vector3dc;
+import org.joml.Vector3ic;
 
-public class ChunkSectionTilePos
-    implements Pos3i<ChunkSectionTilePos> {
+import java.io.Externalizable;
+import java.io.IOException;
+import java.io.ObjectInput;
+import java.io.ObjectOutput;
+
+public class ChunkSectionTilePos implements Externalizable, Cloneable, ChunkSectionTilePosc {
     public int x;
     public int y;
     public int z;
 
+    public ChunkSectionTilePos() {
+        this.x = 0;
+        this.y = 0;
+        this.z = 0;
+    }
+
     public ChunkSectionTilePos(final int x, final int y, final int z) {
         this.x = Integer.remainderUnsigned(x, Chunk.CHUNK_SIZE_X);
         this.y = Integer.remainderUnsigned(y, ChunkSection.SECTION_SIZE_Y);
@@ -27,16 +40,16 @@ public class ChunkSectionTilePos
         this(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
     }
 
-    public ChunkSectionTilePos(final @NotNull ChunkTilePos tilePos) {
-        this(tilePos.x, tilePos.y, tilePos.z);
+    public ChunkSectionTilePos(final @NotNull ChunkTilePosc tilePos) {
+        this(tilePos.x(), tilePos.y(), tilePos.z());
     }
 
-    public ChunkSectionTilePos(final @NotNull TilePos tilePos) {
-        this(tilePos.x, tilePos.y, tilePos.z);
+    public ChunkSectionTilePos(final @NotNull TilePosc tilePos) {
+        this(tilePos.x(), tilePos.y(), tilePos.z());
     }
 
-    public ChunkSectionTilePos(final @NotNull Vec3 vec) {
-        this(vec.x, vec.y, vec.z);
+    public ChunkSectionTilePos(final @NotNull Vector3dc vec) {
+        this(vec.x(), vec.y(), vec.z());
     }
 
     public ChunkSectionTilePos(final @NotNull Entity entity) {
@@ -58,30 +71,123 @@ public class ChunkSectionTilePos
         return this.z;
     }
 
+    public @NotNull ChunkSectionTilePos set(final int x, final int y, final int z) {
+        this.x = Integer.remainderUnsigned(x, Chunk.CHUNK_SIZE_X);
+        this.y = Integer.remainderUnsigned(y, ChunkSection.SECTION_SIZE_Y);
+        this.z = Integer.remainderUnsigned(z, Chunk.CHUNK_SIZE_Z);
+        return this;
+    }
+
+    public @NotNull ChunkSectionTilePos set(final @NotNull ChunkTilePosc pos) {
+        return set(pos.x(), pos.y(), pos.z());
+    }
+
     @Override
-    public @NotNull ChunkSectionTilePos add(final int x, final int y, final int z) {
-        return new ChunkSectionTilePos(this.x + x, this.y + y, this.z + z);
+    public @NotNull ChunkSectionTilePos add(int x, int y, int z, @NotNull ChunkSectionTilePos dest) {
+        return dest.set(this.x + x, this.y + y, this.z + z);
     }
 
-    public @NotNull ChunkTilePos toChunkTilePos(final int sectionIndex) {
-        return new ChunkTilePos(this.x, this.y + sectionIndex * ChunkSection.SECTION_SIZE_Y, this.z);
+    @Override
+    public @NotNull ChunkSectionTilePos add(@NotNull Vector3ic v, @NotNull ChunkSectionTilePos dest) {
+        return add(v.x(), v.y(), v.z(), dest);
+    }
+
+    @Override
+    public @NotNull ChunkSectionTilePos add(@NotNull Direction dir, @NotNull ChunkSectionTilePos dest) {
+        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+    }
+
+    public @NotNull ChunkSectionTilePos add(int x, int y, int z) {
+        return add(x, y, z, this);
+    }
+
+    public @NotNull ChunkSectionTilePos add(@NotNull Vector3ic v) {
+        return add(v.x(), v.y(), v.z(), this);
+    }
+
+    public @NotNull ChunkSectionTilePos add(@NotNull Direction dir) {
+        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), this);
+    }
+
+    @Override
+    public @NotNull ChunkSectionTilePos sub(int x, int y, int z, @NotNull ChunkSectionTilePos dest) {
+        return dest.set(this.x - x, this.y - y, this.z - z);
+    }
+
+    @Override
+    public @NotNull ChunkSectionTilePos sub(@NotNull Vector3ic v, @NotNull ChunkSectionTilePos dest) {
+        return sub(v.x(), v.y(), v.z(), dest);
+    }
+
+    @Override
+    public @NotNull ChunkSectionTilePos sub(@NotNull Direction dir, @NotNull ChunkSectionTilePos dest) {
+        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+    }
+
+    public @NotNull ChunkSectionTilePos sub(int x, int y, int z) {
+        return sub(x, y, z, this);
+    }
+
+    public @NotNull ChunkSectionTilePos sub(@NotNull Vector3ic v) {
+        return sub(v.x(), v.y(), v.z(), this);
+    }
+
+    public @NotNull ChunkSectionTilePos sub(@NotNull Direction dir) {
+        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), this);
+    }
+
+    @Override
+    public double distance(@NotNull ChunkSectionTilePosc pos) {
+        int dx = this.x - pos.x();
+        int dy = this.y - pos.y();
+        int dz = this.z - pos.z();
+        return Math.sqrt(dx * dx + dy * dy + dz * dz);
+    }
+
+    @Override
+    public double distanceSquared(@NotNull ChunkSectionTilePosc pos) {
+        int dx = this.x - pos.x();
+        int dy = this.y - pos.y();
+        int dz = this.z - pos.z();
+        return dx * dx + dy * dy + dz * dz;
     }
 
     public boolean inBounds() {
         return this.x >= 0 && this.x < Chunk.CHUNK_SIZE_X && this.y >= 0 && this.y < ChunkSection.SECTION_SIZE_Y && this.z >= 0 && this.z < Chunk.CHUNK_SIZE_Z;
     }
 
+    @Override
+    public boolean equals(int x, int y, int z) {
+        return this.x == x && this.y == y && this.z == z;
+    }
+
     @Override
     public boolean equals(final Object obj) {
-        if (!(obj instanceof final @NotNull ChunkSectionTilePos other)) {
-            return false;
-        } else {
+        if (obj instanceof final @NotNull ChunkSectionTilePos other) {
             return this.x == other.x && this.y == other.y && this.z == other.z;
         }
+        return false;
     }
 
     @Override
     public int hashCode() {
         return MathHelper.cantor(MathHelper.cantor(this.x, this.y), this.z);
     }
+
+    @Override
+    public void writeExternal(ObjectOutput out) throws IOException {
+        out.writeInt(this.x);
+        out.writeInt(this.y);
+        out.writeInt(this.z);
+    }
+
+    @Override
+    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
+        set(in.readInt(), in.readInt(), in.readInt());
+    }
+
+    @Override
+    protected Object clone() throws CloneNotSupportedException {
+        return super.clone();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePosc.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePosc.java
new file mode 100644
index 000000000..a6ad12d5e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkSectionTilePosc.java
@@ -0,0 +1,37 @@
+package net.minecraft.core.world.pos;
+
+import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3ic;
+
+/**
+ * Tile pos relative to a chunk section
+ */
+public interface ChunkSectionTilePosc {
+
+    int x();
+
+    int y();
+
+    int z();
+
+    @NotNull ChunkSectionTilePos add(int x, int y, int z, @NotNull ChunkSectionTilePos dest);
+
+    @NotNull ChunkSectionTilePos add(@NotNull Vector3ic v, @NotNull ChunkSectionTilePos dest);
+
+    @NotNull ChunkSectionTilePos add(@NotNull Direction dir, @NotNull ChunkSectionTilePos dest);
+
+    @NotNull ChunkSectionTilePos sub(int x, int y, int z, @NotNull ChunkSectionTilePos dest);
+
+    @NotNull ChunkSectionTilePos sub(@NotNull Vector3ic v, @NotNull ChunkSectionTilePos dest);
+
+    @NotNull ChunkSectionTilePos sub(@NotNull Direction dir, @NotNull ChunkSectionTilePos dest);
+
+    double distance(@NotNull ChunkSectionTilePosc pos);
+
+    double distanceSquared(@NotNull ChunkSectionTilePosc pos);
+
+    boolean inBounds();
+
+    boolean equals(int x, int y, int z);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
index 48c5289ae..97182c78c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
@@ -1,19 +1,31 @@
 package net.minecraft.core.world.pos;
 
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Math;
+import org.joml.Vector3ic;
 
-public class ChunkTilePos
-    implements Pos3i<ChunkTilePos> {
+import java.io.Externalizable;
+import java.io.IOException;
+import java.io.ObjectInput;
+import java.io.ObjectOutput;
+
+public class ChunkTilePos implements Externalizable, Cloneable, ChunkTilePosc {
     public int x;
     public int y;
     public int z;
 
+    public ChunkTilePos() {
+        this.x = 0;
+        this.y = 0;
+        this.z = 0;
+    }
+
     public ChunkTilePos(final int x, final int y, final int z) {
         this.x = Integer.remainderUnsigned(x, Chunk.CHUNK_SIZE_X);
         this.y = y;
@@ -28,12 +40,12 @@ public class ChunkTilePos
         this(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
     }
 
-    public ChunkTilePos(final @NotNull TilePos tilePos) {
-        this(tilePos.x, tilePos.y, tilePos.z);
+    public ChunkTilePos(final @NotNull TilePosc tilePos) {
+        this(tilePos.x(), tilePos.y(), tilePos.z());
     }
 
-    public ChunkTilePos(final @NotNull Vec3 vec) {
-        this(vec.x, vec.y, vec.z);
+    public ChunkTilePos(final @NotNull ChunkTilePosc tilePos) {
+        this(tilePos.x(), tilePos.y(), tilePos.z());
     }
 
     public ChunkTilePos(final @NotNull Entity entity) {
@@ -55,48 +67,161 @@ public class ChunkTilePos
         return this.z;
     }
 
-    public @NotNull ChunkTilePos add(final int x, final int y, final int z) {
-        return new ChunkTilePos(this.x + x, this.y + y, this.z + z);
-    }
-
-    /**
-     * Modifies the position of the tile pos, probably unsafe unless you know modifications will not cause unintended side effects
-     * @return self
-     */
     public @NotNull ChunkTilePos set(final int x, final int y, final int z) {
-        this.x = x;
+        this.x = Integer.remainderUnsigned(x, Chunk.CHUNK_SIZE_X);
         this.y = y;
-        this.z = z;
+        this.z = Integer.remainderUnsigned(z, Chunk.CHUNK_SIZE_Z);
         return this;
     }
 
-    public @NotNull TilePos toTilePos(final @NotNull ChunkPos chunkPos) {
-        return new TilePos(chunkPos, this);
+    public @NotNull ChunkTilePos set(@NotNull ChunkTilePosc pos) {
+        return set(pos.x(), pos.y(), pos.z());
+    }
+
+    public @NotNull ChunkTilePos set(@NotNull TilePosc pos) {
+        return set(pos.x(), pos.y(), pos.z());
+    }
+
+    @Override
+    public @NotNull ChunkTilePos add(int x, int y, int z, @NotNull ChunkTilePos dest) {
+        return dest.set(this.x + x, this.y + y, this.z + z);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos add(@NotNull Vector3ic v, @NotNull ChunkTilePos dest) {
+        return add(v.x(), v.y(), v.z(), dest);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos add(@NotNull Direction dir, @NotNull ChunkTilePos dest) {
+        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+    }
+
+    public @NotNull ChunkTilePos add(int x, int y, int z) {
+        return add(x, y, z, this);
+    }
+
+    public @NotNull ChunkTilePos add(@NotNull Vector3ic v) {
+        return add(v.x(), v.y(), v.z(), this);
+    }
+
+    public @NotNull ChunkTilePos add(@NotNull Direction dir) {
+        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), this);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos sub(int x, int y, int z, @NotNull ChunkTilePos dest) {
+        return dest.set(this.x - x, this.y - y, this.z - z);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos sub(@NotNull Vector3ic v, @NotNull ChunkTilePos dest) {
+        return sub(v.x(), v.y(), v.z(), dest);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos sub(@NotNull Direction dir, @NotNull ChunkTilePos dest) {
+        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+    }
+
+    public @NotNull ChunkTilePos sub(int x, int y, int z) {
+        return sub(x, y, z, this);
+    }
+
+    public @NotNull ChunkTilePos sub(@NotNull Vector3ic v) {
+        return sub(v.x(), v.y(), v.z(), this);
     }
 
-    public @NotNull ChunkSectionTilePos toChunkSectionTilePos() {
-        return new ChunkSectionTilePos(this);
+    public @NotNull ChunkTilePos sub(@NotNull Direction dir) {
+        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), this);
+    }
+
+    @Override
+    public double distance(@NotNull ChunkTilePosc pos) {
+        int dx = pos.x() - this.x;
+        int dy = pos.y() - this.y;
+        int dz = pos.z() - this.z;
+        return Math.sqrt(dx * dx + dy * dy + dz * dz);
+    }
+
+    @Override
+    public double distanceSquared(@NotNull ChunkTilePosc pos) {
+        int dx = pos.x() - this.x;
+        int dy = pos.y() - this.y;
+        int dz = pos.z() - this.z;
+        return dx * dx + dy * dy + dz * dz;
     }
 
     public boolean inBounds() {
         return this.x >= 0 && this.x < Chunk.CHUNK_SIZE_X && this.y >= 0 && this.y < Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y && this.z >= 0 && this.z < Chunk.CHUNK_SIZE_Z;
     }
 
+    @Override
+    public boolean equals(int x, int y, int z) {
+        return false;
+    }
+
+    @Override
+    public @NotNull ChunkTilePos up(@NotNull ChunkTilePos dest) {
+        return add(Direction.UP, dest);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos down(@NotNull ChunkTilePos dest) {
+        return add(Direction.DOWN, dest);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos north(@NotNull ChunkTilePos dest) {
+        return add(Direction.NORTH, dest);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos south(@NotNull ChunkTilePos dest) {
+        return add(Direction.SOUTH, dest);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos west(@NotNull ChunkTilePos dest) {
+        return add(Direction.WEST, dest);
+    }
+
+    @Override
+    public @NotNull ChunkTilePos east(@NotNull ChunkTilePos dest) {
+        return add(Direction.EAST, dest);
+    }
+
     public int getSectionIndex() {
         return this.y / ChunkSection.SECTION_SIZE_Y;
     }
 
     @Override
     public boolean equals(final @Nullable Object obj) {
-        if (!(obj instanceof final @NotNull ChunkTilePos other)) {
-            return false;
-        } else {
+        if (obj instanceof final @NotNull ChunkTilePos other) {
             return this.x == other.x && this.y == other.y && this.z == other.z;
         }
+        return false;
     }
 
     @Override
     public int hashCode() {
         return MathHelper.cantor(MathHelper.cantor(this.x, this.y), this.z);
     }
+
+    @Override
+    public void writeExternal(ObjectOutput out) throws IOException {
+        out.writeInt(this.x);
+        out.writeInt(this.y);
+        out.writeInt(this.z);
+    }
+
+    @Override
+    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
+        set(in.readInt(), in.readInt(), in.readInt());
+    }
+
+    @Override
+    protected Object clone() throws CloneNotSupportedException {
+        return super.clone();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePosc.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePosc.java
new file mode 100644
index 000000000..d002a421c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePosc.java
@@ -0,0 +1,51 @@
+package net.minecraft.core.world.pos;
+
+import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3ic;
+
+/**
+ * Tile pos relative to a chunk
+ */
+public interface ChunkTilePosc {
+
+    int x();
+
+    int y();
+
+    int z();
+
+    @NotNull ChunkTilePos add(int x, int y, int z, @NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos add(@NotNull Vector3ic v, @NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos add(@NotNull Direction dir, @NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos sub(int x, int y, int z, @NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos sub(@NotNull Vector3ic v, @NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos sub(@NotNull Direction dir, @NotNull ChunkTilePos dest);
+
+    double distance(@NotNull ChunkTilePosc pos);
+
+    double distanceSquared(@NotNull ChunkTilePosc pos);
+
+    int getSectionIndex();
+
+    boolean inBounds();
+
+    boolean equals(int x, int y, int z);
+
+    @NotNull ChunkTilePos up(@NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos down(@NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos north(@NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos south(@NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos west(@NotNull ChunkTilePos dest);
+
+    @NotNull ChunkTilePos east(@NotNull ChunkTilePos dest);
+}
